import java.awt.*;
import java.net.MalformedURLException;
import java.net.URL;

import javax.swing.*;

public class View extends JFrame {
	
	/**
	 * Constructor
	 */
	
	public View()
	{
		this.setTitle("Medientechnik");
		
		// Creating the menu bar
		
		JMenuBar menuBar = new JMenuBar();
		
		JMenu menu = new JMenu("File");
		JMenuItem load = new JMenuItem("Load File");
		JMenuItem exit = new JMenuItem("Exit");
		menu.add(load);
		menu.addSeparator();
		menu.add(exit);
		menuBar.add(menu);
		
		JMenu filtermenu = new JMenu("Filters");
		JCheckBoxMenuItem filter_blur = new JCheckBoxMenuItem("Blur");
		JCheckBoxMenuItem filter_distort = new JCheckBoxMenuItem("Distort");
		JCheckBoxMenuItem filter_sharpen = new JCheckBoxMenuItem("Sharpen");
		JCheckBoxMenuItem filter_contrast = new JCheckBoxMenuItem("Contrast");
		JCheckBoxMenuItem filter_invert = new JCheckBoxMenuItem("Invert");
		JCheckBoxMenuItem filter_bw = new JCheckBoxMenuItem("B/W");
		JCheckBoxMenuItem filter_zoom = new JCheckBoxMenuItem("Zoom");
		filtermenu.add(filter_blur);
		filtermenu.add(filter_distort);
		filtermenu.add(filter_sharpen);
		filtermenu.add(filter_contrast);
		filtermenu.add(filter_invert);
		filtermenu.add(filter_bw);
		filtermenu.add(filter_zoom);

		menuBar.add(filtermenu);
		
		JMenu about = new JMenu("About");
		JMenuItem about_yapv = new JMenuItem("Medientechnik");
		about.add(about_yapv);
		menuBar.add(about);
		
		this.setJMenuBar(menuBar);
		
		//---------------------------------------------------------------------------
		// Main content panel with BorderLayout
		
		JPanel content = new JPanel();
		content.setLayout(new BorderLayout());
		this.getContentPane().add(content);

		//---------------------------------------------------------------------------
		// Picture panel with GridBagLayout
		
		JPanel pictures = new JPanel();
		GridBagConstraints c = new GridBagConstraints();
		c.fill = GridBagConstraints.CENTER;

		pictures.setLayout(new GridBagLayout());
		ImageIcon image = null;
		ImageIcon image2 = null;
		
		try {
			image = new ImageIcon(new URL("http://www.medien.ifi.lmu.de/lehre/ss09/akf/Infrarot_RichardAtterer01.jpeg"));
			image2 = new ImageIcon(new URL("http://www.medien.ifi.lmu.de/lehre/ss09/akf/Infrarot_RichardAtterer02.jpeg"));
			
			// Because image2 will be an edited version of image we'll take image.getWidth() and multiply it
			// Also scaling two different images won't be necessary (in future) 
			
			double screenWidth = Toolkit.getDefaultToolkit().getScreenSize().getWidth();
			double screenHeight = Toolkit.getDefaultToolkit().getScreenSize().getHeight();
			
			
			// 30px for window borders...
			if ((image.getImage().getWidth(null)*2 + 30) > screenWidth)
			{
				double scale = (screenWidth - 30) / (image.getImage().getWidth(null)*2);
				int newWidth =  (int)(scale * image.getImage().getWidth(null));
				int newHeight = (int)(scale * image.getImage().getHeight(null));
				
				Image tmpImage = image.getImage().getScaledInstance(newWidth, newHeight, Image.SCALE_SMOOTH);
				image.setImage(tmpImage);
				
				tmpImage = image2.getImage().getScaledInstance(newWidth, newHeight, Image.SCALE_SMOOTH);
				image2.setImage(tmpImage);
				
			}
			
			// 150px for effect panel, menu bar, window borders...
			if (image.getImage().getHeight(null) + 150 > screenHeight)
			{
				double scale = (screenHeight - 150) / (image.getImage().getHeight(null));
				int newWidth =  (int)(scale * image.getImage().getWidth(null));
				int newHeight = (int)(scale * image.getImage().getHeight(null));
				
				Image tmpImage = image.getImage().getScaledInstance(newWidth, newHeight, Image.SCALE_SMOOTH);
				image.setImage(tmpImage);
				
				tmpImage = image2.getImage().getScaledInstance(newWidth, newHeight, Image.SCALE_SMOOTH);
				image2.setImage(tmpImage);
			}
		} catch (MalformedURLException e) {
			e.printStackTrace();
		}
		
		JLabel img_label = new JLabel(image);
		JLabel img_label2 = new JLabel(image2);
		image.setImageObserver(img_label);
		image2.setImageObserver(img_label2);
		c.weightx = 0.5;
		c.gridx = 0;
		c.gridy = 0;
        pictures.add(img_label, c);
        c.weightx = 0.5;
        c.gridx = 1;
        c.gridy = 0;
        pictures.add(img_label2, c);
        c.weightx = 0.5;
        c.gridx = 0;
        c.gridy = 1;
        pictures.add(new JLabel("Original"), c);
        c.weightx = 0.5;
        c.gridx = 1;
        c.gridy = 1;
        pictures.add(new JLabel("Preview"), c);
        content.add(pictures, BorderLayout.NORTH);
        
        // Separator
        
        JSeparator separator = new JSeparator(JSeparator.HORIZONTAL);
        content.add(separator, BorderLayout.CENTER);
 
        
		//---------------------------------------------------------------------------        
        // Panel for buttons & checkboxes with FlowLayout
        
        JPanel allEffects = new JPanel();
        allEffects.setLayout(new FlowLayout());
        
        JRadioButton allEffectsButton = new JRadioButton("Alle Effekte");
        //..
        allEffectsButton.setSelected(false);
       //..
	   
	   JButton random_button = new JButton("Random");
	   
        
       JLabel effect_label = new JLabel("Filters:");
       
       JTextField filterTextField = new JTextField(100);
        
       allEffects.add(allEffectsButton);
	   allEffects.add(random_button);
       allEffects.add(effect_label);
       allEffects.add(filterTextField);
        
	    
		content.add(allEffects, BorderLayout.SOUTH);
		
		this.pack();
		this.setVisible(true);
	}
}
